function outImage = ahe(inImage, numofBin, windowSize)
% Adaptive histogram equalization.

%inImage = double(inImage);
blockImage = zeros(windowSize);
[row, col] = size(inImage);
outImage = zeros(row, col);
rowofWindow = ceil(row/windowSize);
colofWindow = ceil(col/windowSize);
maxMat = zeros(rowofWindow, colofWindow);
minMat = zeros(rowofWindow, colofWindow);

% Get the min and max pixel value for each block(tile).
for i = 1:rowofWindow
    for j = 1:colofWindow
        rowArray = mod((i-1)*windowSize+1:i*windowSize, row);
        colArray = mod((j-1)*windowSize+1:j*windowSize, col);
        rowArray(find(rowArray == 0)) = row;
        colArray(find(colArray == 0)) = col;
        blockImage = inImage(rowArray, colArray);
        minMat(i,j) = min(min(blockImage));
        maxMat(i,j) = max(max(blockImage));
    end;
end;

% smooth the min and max pixel value of each block by averaging its
% neighbor.
for i = 2:rowofWindow-1
    for j = 2:colofWindow-1
        minMat(i,j) = 0.25 * (minMat(i-1,j) + minMat(i+1,j) + minMat(i,j-1) + minMat(i,j+1));
        maxmat(i,j) = -.25 * (maxMat(i-1,j) + maxMat(i+1,j) + maxMat(i,j-1) + maxMat(i,j+1));
    end;
end;        
        
for i = 1:rowofWindow
    for j = 1: colofWindow
        rowArray = mod((i-1)*windowSize+1:i*windowSize, row);
        colArray = mod((j-1)*windowSize+1:j*windowSize, col);
        rowArray(find(rowArray == 0)) = row;
        colArray(find(colArray == 0)) = col;
        blockImage = inImage(rowArray, colArray);
        minv = min(min(blockImage));
        maxv = max(max(blockImage));
        outImage(rowArray, colArray) = ...
            histoeq(blockImage, numofBin, minMat(i,j), maxMat(i,j));
    end;
end;
            
        