function outImage = histoeq2(myImage, numofBin, minv, maxv, alpha)

cumuFun = zeros(1, numofBin);
myImage = double(myImage);
freq = histogram(myImage, numofBin, minv, maxv);
for i = 1:numofBin
    if i == 1
        cumuFun(i) = freq(1);
    else
        cumuFun(i) = cumuFun(i-1) + freq(i);
    end;
end;
[row, col] = size(myImage);
outImage = zeros(row, col);
K = (maxv - minv+1)/numofBin;  % number of gray levels in one bin.
for i = 1:row
    for j = 1:col
        if (myImage(i,j) >= minv & myImage(i,j) <= maxv)
            bin = floor((myImage(i,j) - minv)/K);
            outImage(i,j) = (1-alpha) * myImage(i,j)/255 + alpha * cumuFun(bin+1);
        else
            outImage(i,j) = myImage(i,j);
        end;
    end;
end;

        