function outImage = histoeq_clahe(myImage, numofBin, minv, maxv, limit)

cumuFun = zeros(1, numofBin);
freq = histogram_clahe(myImage, numofBin, minv, maxv, limit);
for i = 1:numofBin
    if i == 1
        cumuFun(i) = freq(1);
    else
        cumuFun(i) = cumuFun(i-1) + freq(i);
    end;
end;
[row, col] = size(myImage);
outImage = zeros(row, col);
K = (double(maxv) - double(minv)+1)/double(numofBin);  % number of gray levels in one bin.

for i = 1:row
    for j = 1:col
        if (myImage(i,j) >= minv & myImage(i,j) <= maxv)
            bin = floor((myImage(i,j) - minv)/K);
            if bin == numofBin
                outImage(i,j) = cumuFun(bin) * (maxv - minv) + minv;
            else
                outImage(i,j) = cumuFun(bin+1) * (maxv - minv) + minv;
            end;
        else
            outImage(i,j) = myImage(i,j);
        end;
    end;
end;
