function freq = histogram(myimage, n, min, max)

% Compute histogram of an image. 
% Input: I is the file name which contains a integers or float point image
% format (have to be grayscale). n is the number of bin. min and max is 
% the minima and maximal value of the image. 

% Output: freq is vector with the frequency of each pixel. 

myimage = double(myimage);
freq = zeros(1,n);
[row, col] = size(myimage);
K = (double(max) - double(min)+1.0)/double(n);  % number of gray levels in one bin.
M = 0;              % number of all pixels btw min and max.
for i = 1:row
    for j = 1:col
        if (myimage(i,j) >= min & myimage(i,j) <= max)
            bin = floor((myimage(i,j) - min)/K);
            if bin == n
                freq(bin) = freq(bin) + 1;
            else
                freq(bin+1) = freq(bin+1) + 1;
            end;
            M = M + 1;
        end;
    end;
end;

freq = freq/M;
